#include <windows.h>
#include <ppl.h>
#include <array>
#include <numeric>
#include <iostream>

using namespace Concurrency;
using namespace std;

// ޹ Լ ȣϰ Լ  ҿ ð ȯ
template <class Function>
__int64 time_call(Function&& f)
{
	__int64 begin = GetTickCount();
	f();
	return GetTickCount() - begin;
}

// ޹  Ҽ ƴ ǴϿ ȯ
bool is_prime(int n)
{
	if (n < 2)
		return false;
	for (int i = 2; i < n; ++i)
	{
		if ((n % i) == 0)
			return false;
	}
	return true;
}

int wmain()
{
	// 20 ũ  迭 
	array<int, 200000> a;

	//    ε  (a[i] = i) 
	iota(begin(a), end(a), 0);

	int prime_sum;
	__int64 elapsed;

	// 迭    Ҽ  
	elapsed = time_call([&] {
		// 迭 a   Ҽ   ϰ Ҽ ƴ  0 
		transform(begin(a), end(a), begin(a), [](int i) {
			return is_prime(i) ? i : 0;
		});
		// 迭 a հ 
		prime_sum = accumulate(begin(a), end(a), 0);
	});
	wcout << prime_sum << endl;
	wcout << L"serial time: " << elapsed << L" ms" << endl << endl;

	// 迭  缳
	iota(begin(a), end(a), 0);

	//   ۾  ˰ Ͽ 
	elapsed = time_call([&] {
		parallel_transform(begin(a), end(a), begin(a), [](int i) {
			return is_prime(i) ? i : 0;
		});
		prime_sum = parallel_reduce(begin(a), end(a), 0);
	});
	wcout << prime_sum << endl;
	wcout << L"parallel time: " << elapsed << L" ms" << endl << endl;
}
