#include <ppl.h>
#include <iostream>
#include <sstream>

using namespace Concurrency;
using namespace std;

// task_group_status ü Ʈ  ȯ
std::wstring get_status_string(task_group_status status)
{
    switch (status)
    {
    case not_complete:
        return L"not_complete";

    case completed:
        return L"completed";

    case canceled:
        return L"canceled";
    }
    return L"";
}

// ۾ Լ
bool work(int index)
{
    if (index == 100)
        return false;

    return true;
}

int wmain()
{
    // cancellation_token_source ü ϰ 
    // ½ũ ׷ tg2   ش ū ϵ 
    cancellation_token_source cts;
    structured_task_group tg2(cts.get_token());

    // ڽ ½ũ t4 
    auto t4 = make_task([&cts] {

        for (int i = 0; i < 1000; ++i)
        {
            // ۾ Լ ϰ   false 
            // ū  ۾  û  ½ũ 
            bool succeeded = work(i);
            if (!succeeded)
            {
                wcout << L"Canceling task group..." << endl;
                cts.cancel();
                break;
            }
        }
    });

    // ڽ ½ũ t5 
    auto t5 = make_task([] {

        for (int i = 0; i < 1000000; ++i)
        {
            // 100 ݺ   û 
            if ((i % 100) == 0)
            {
                if (is_current_task_group_canceling())
                {
                    // ۾  û ߻Ǹ ̴ ۾ ߴϰ ½ũ 
                    wcout << L"The task was canceled." << endl;
                    break;
                }
            }

            // TODO: ۾ 
        }
    });

    // ڽ ½ũ ϰ  
    tg2.run(t4);
    tg2.run(t5);
    task_group_status status = tg2.wait();

    // ½ũ ׷  
    wcout << L"Task group status: " << get_status_string(status) << endl;
}
