#include <ppl.h>
#include <list>
#include <iostream>
#include <algorithm>
#include <sstream>
#include <random>

using namespace Concurrency;
using namespace std;

// Ʈ  ǥ tree Ŭ
template <typename T>
class tree
{
public:
    explicit tree(T data)
        : _data(data)
    {
    }

    //   ȯ
    T get_data() const
    {
        return _data;
    }

    //  忡 ڽ  ߰
    void add_child(tree& child)
    {
        _children.push_back(child);
    }

    // Ʈ Ե  带 ķ ȸϸ ־ ۾ 
    template<class Function>
    void for_all(Function& action)
    {
        // ڽ 尡    ڽ 忡   Լ ȣ
        parallel_for_each(begin(_children), end(_children), [&](tree& child) {
            child.for_all(action);
        });

        // ش 忡 ־ ۾ 
        action(*this);
    }    

private:
    //   
    T _data;
    // ڽ 
    list<tree> _children;
};

// Ʈ  ̿ ڽ   ޹޾ Ʈ 
//   ʹ Generator Լ  ʱȭǸ
// Ʈ ̰  ڽ   1 Ѵ.
template <typename T, class Generator>
tree<T> build_tree(int depth, int child_count, Generator& g)
{
    //  
    tree<T> t(g());

    // ڽ  ߰
    if (depth > 0)
    {
        for(int i = 0; i < child_count; ++i)
        {
            t.add_child(build_tree<T>(depth - 1, child_count + 1, g));
        }
    }

    return t;
}

// Ʈ ־   带 ˻
template <typename T>
void search_for_value(tree<T>& t, int value)
{
    try
    {
        // ־  ˻ϱ ؼ for_all Լ ȣ
        //  ־  ãҴٸ  Żϱ  ܸ ߻Ŵ
        t.for_all([value](const tree<T>& node) {
            if (node.get_data() == value)
            {
                throw &node;
            }
        });
    }
    catch (const tree<T>* node)
    {
        // ־   带 ã 
        wstringstream ss;
        ss << L"Found a node with value " << node->get_data() << L'.' << endl;
        wcout << ss.str();
        return;
    }

    // ־   带 ã  
    wstringstream ss;
    ss << L"Did not find node with value " << value << L'.' << endl;
    wcout << ss.str();
}

int wmain()
{  
    // 4ܰ ̿ 3 ڽ 带  Ʈ 
    mt19937 gen(38);
    tree<int> t = build_tree<int>(4, 3, [&gen]{ return gen()%100000; });

    // Ʈ    ķ ˻
    parallel_invoke(
        [&t] { search_for_value(t, 86131); },
        [&t] { search_for_value(t, 17522); },
        [&t] { search_for_value(t, 32614); }
    );
}