#include <windows.h>
#include <ppl.h>
#include <iostream>
#include <numeric>

using namespace Concurrency;
using namespace std;

// ˻  Ÿ Ŭ
template<typename T>
class Answer
{
public:
    explicit Answer(const T& data)
        : _data(data)
    {
    }

    T get_data() const
    {
        return _data;
    }

    // TODO: ߰ ޼ 

private:
    T _data;

    // TODO: ߰  
};

// 迭 ־  ϴ Ҹ ˻
template<typename T, class Predicate>
Answer<T>* parallel_find_answer(const T a[], size_t count, const Predicate& pred)
{
    // ˻ 
    Answer<T>* answer = nullptr;
    // ÿ  Լ   ߺ ó 
    volatile long first_result = 0;

    // parallel_for Լ ̿Ͽ 迭 Ҹ ķ ˻
    structured_task_group tasks;
    tasks.run_and_wait([&]
    {
        //  Լ ȿ T Ÿ ν  ֵ alias 
        typedef T T;

        parallel_for<size_t>(0, count, [&](const T& n) {
            if (pred(a[n]) && InterlockedExchange(&first_result, 1) == 0)
            {
                //  Լ   ˻  Answer ü Ҵ
                answer = new Answer<T>(a[n]);
                //  ۾ 
                tasks.cancel();
            }
        });
    });

    return answer;
}

int main()
{
    // 1~1000    迭 
    int numbers[1000];
    iota(begin(numbers), end(numbers), 1);

    // 迭 100  ˻
    auto result = parallel_find_answer(numbers, 1000, [](int n){		
        return (n % 100 == 0);
    });

    //   
    if (result)
        wcout << L"Answer: " << result->get_data() << endl;
}
